/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSConsole_h
#define JSConsole_h

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>

namespace WebCore {

class Console;

class JSConsole : public DOMObject {
    typedef DOMObject Base;
public:
    JSConsole(PassRefPtr<JSC::StructureID>, PassRefPtr<Console>);
    virtual ~JSConsole();
    static JSC::JSObject* createPrototype(JSC::ExecState*);
    virtual const JSC::ClassInfo* classInfo() const { return &s_info; }
    static const JSC::ClassInfo s_info;


    // Custom functions
    JSC::JSValuePtr debug(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr error(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr info(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr log(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr warn(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr dir(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr dirxml(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr trace(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr assertCondition(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr count(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr profile(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr profileEnd(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr timeEnd(JSC::ExecState*, const JSC::ArgList&);
    JSC::JSValuePtr group(JSC::ExecState*, const JSC::ArgList&);
    Console* impl() const { return m_impl.get(); }

private:
    RefPtr<Console> m_impl;
};

JSC::JSValuePtr toJS(JSC::ExecState*, Console*);
Console* toConsole(JSC::JSValuePtr);

class JSConsolePrototype : public JSC::JSObject {
public:
    static JSC::JSObject* self(JSC::ExecState*);
    virtual const JSC::ClassInfo* classInfo() const { return &s_info; }
    static const JSC::ClassInfo s_info;
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    JSConsolePrototype(PassRefPtr<JSC::StructureID> structure) : JSC::JSObject(structure) { }
};

// Functions

JSC::JSValuePtr jsConsolePrototypeFunctionDebug(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionError(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionInfo(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionLog(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionWarn(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionDir(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionDirxml(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionTrace(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionAssert(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionCount(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionProfile(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionProfileEnd(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionTime(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionTimeEnd(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionGroup(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);
JSC::JSValuePtr jsConsolePrototypeFunctionGroupEnd(JSC::ExecState*, JSC::JSObject*, JSC::JSValuePtr, const JSC::ArgList&);

} // namespace WebCore

#endif
